<?php if (!defined('PLX_ROOT')) exit;

class plnAdminPluginIcon extends plxPlugin 
{
    ##############################################################################################
	#
	# Le constructeur
	#
	##############################################################################################	
	public function __construct($default_lang) 
	{
		parent::__construct($default_lang);

        $this->CacheDirectory = PLX_ROOT."cache/";

        $this->addHook('AdminTopMenus','AdminTopMenus');
	}

    ##############################################################################################
    #
    # A l'activation on créé le répertoire de cache s'il n'existe pas déjà
    #
    ##############################################################################################  
    public function onActivate()
    {
        mkdir($this->CacheDirectory,0750);
    }
    ##############################################################################################
    #
    # On modifie les liens d'accès aux plugins pour rajouter une petit icône
    #
    ##############################################################################################  
    public function AdminTopMenus()
    {
        // On commence par vérifier que toutes les miniatures des icones sont présentes
        $plxMotor = plxAdmin::getInstance();
        foreach($plxMotor->plxPlugins->aPlugins as $PlugName => $Plugin)
        {
            //format d'icones officiellement autorisés : jpg, gif, png
            $icon = "";
            if(is_file(PLX_PLUGINS.$PlugName."/icon.png"))
                $icon = "icon.png";
                elseif(is_file(PLX_PLUGINS.$PlugName."/icon.jpg"))
                    $icon = "icon.jpg";
                    elseif(is_file(PLX_PLUGINS.$PlugName."/icon.gif"))
                        $icon = "icon.gif";
            // Si une icone existe, on vérifie si sa miniature existe
            if($icon != '')
            {
                // Si la miniature n'existe pas, où si elle est plus vieille que l'icone du plugin, on fabrique la miniature.
                if(!is_file($this->CacheDirectory.$PlugName."_icon") 
                    or filemtime(PLX_PLUGINS.$PlugName."/".$icon) > filemtime($this->CacheDirectory.$PlugName."_icon"))
                    plxUtils::makeThumb(PLX_PLUGINS.$PlugName."/".$icon,$this->CacheDirectory.$PlugName."_icon","16","16",80);
            }
            else // s'il n'y a aucun icône, on détruit une éventuelle miniature
                if(is_file($this->CacheDirectory.$PlugName."_icon")) unlink($this->CacheDirectory.$PlugName."_icon");
        }

        // ensuite pour chaque plugin ayant une page "admin", on affiche l'icone
        $string = '
            foreach($menus as $num => $menu) {
                if(preg_match("/href=\"plugin.php\?p=([a-zA-Z]*)/",$menu,$res) and is_file("'.$this->CacheDirectory.'".$res[1]."_icon"))
                {   
                    $img="<img style=\"margin-left:2px;margin-top:2px;position:absolute;\" src=\"'.$this->CacheDirectory.'".$res[1]."_icon\">";
                    $menus[$num]=preg_replace("#</a>#","</a>".$img,$menu);
                }
            }
        ';
        echo "<?php ".$string." ?>";
    }
}